<template>
  <b-container>
    <b-row>
      <b-col>
        <b-jumbotron
          bg-variant="primary"
          text-variant="white"
          header-level="1"
          header="Projects"
        />
      </b-col>
    </b-row>
    <b-row
      v-for="company in companies"
      :key="company.company_name"
    >
      <b-col>
        <b-card
          class="mb-4"
          bg-variant="dark"
          text-variant="white"
        >
          <h2>{{ company.company_name }}</h2>
          <dl class="row">
            <dt class="col-sm-2">
              Description
            </dt>
            <dd class="col-sm-10">
              {{ company.description }}
            </dd>
            <dt class="col-sm-2">
              Website
            </dt>
            <dd class="col-sm-10">
              <b-link :href="company.website">
                {{ company.website }}
              </b-link>
            </dd>
            <dt class="col-sm-2">
              Start
            </dt>
            <dd class="col-sm-10">
              {{ company.start }}
            </dd>
            <dt class="col-sm-2">
              End
            </dt>
            <dd class="col-sm-10">
              {{ company.end }}
            </dd>
          </dl>

          <h3>Projects</h3>
          <div
            v-for="project in company.projects"
            :key="project.project_name"
          >
            <hr>
            <div class="pl-4">
              <h4>{{ project.project_name }}</h4>
              <dl class="row">
                <dt class="col-sm-2">
                  Description
                </dt>
                <dd class="col-sm-10">
                  {{ project.description }}
                </dd>
                <dt
                  v-if="project.link"
                  class="col-sm-2"
                >
                  Link
                </dt>
                <dd
                  v-if="project.link"
                  class="col-sm-10"
                >
                  <b-link :href="project.link">
                    {{ project.link }}
                  </b-link>
                </dd>
                <dt class="col-sm-2">
                  Duration
                </dt>
                <dd class="col-sm-10">
                  {{ project.duration }}
                </dd>
                <dt class="col-sm-2">
                  Roles
                </dt>
                <dd class="col-sm-10">
                  {{ project.roles.join(', ') }}
                </dd>
                <dt class="col-sm-2">
                  Technologies
                </dt>
                <dd class="col-sm-10">
                  {{ project.technologies.join(', ') }}
                </dd>
                <dt class="col-sm-12">
                  Details
                </dt>
                <dd class="col-sm-12">
                  <ul>
                    <li
                      v-for="key_point in project.key_points"
                      :key="key_point"
                    >
                      {{ key_point }}
                    </li>
                  </ul>
                </dd>
              </dl>
            </div>
          </div>
        </b-card>
      </b-col>
    </b-row>
  </b-container>
</template>

<script>
export default {
  name: "ProjectsView",
  data: function() {
    return {
      companies: [
        {
          company_name: "Strathcom",
          description:
            "A full-service bi-lingual marketing agency providing the latest online management and marketing tools for automotive Retailers",
          website: "https://www.strathcom.com",
          start: "July 2019",
          end: "March 2020",
          projects: [
            {
              project_name: "Leads API",
              link: null,
              description:
                "An API used by Strathcom websites to send customer leads data to different OEM endpoints",
              duration: "1 Month",
              roles: ["Software Developer"],
              technologies: [
                "AWS API Gateway",
                "AWS Cloudwatch",
                "AWS Lambda",
                "Boto 3",
                "Flask",
                "Git",
                "GitHub Actions",
                "GitHub",
                "Make",
                "Python",
                "REST",
                "Terraform"
              ],
              key_points: [
                "Managed using Shape Up and open source style Request for Comments",
                "New product development",
                "Planned 6 week projects by defining a problem and solution, listing architectural considerations, resources needed (developers, stake holders, etc), and definition of done",
                "Worked with support specialists to clarify requirements and test software to ensure project was headed in correct direction",
                "Encouraged use of TDD, design principles, and design patterns via presentations, book clubs, and hands-on pair programming"
              ]
            },
            {
              project_name: "Incentive Service",
              link: null,
              description:
                "An internal API used by websites and other services to retrieve incentive data from a variety of different sources",
              duration: "2 Months",
              roles: ["Software Developer"],
              technologies: [
                "AWS DynamoDB",
                "AWS ECR",
                "AWS ECS",
                "Boto 3",
                "Docker",
                "Flask",
                "Git",
                "GitHub Actions",
                "GitHub",
                "Jenkins (later replaced with GitHub Actions)",
                "Make",
                "Python",
                "REST"
              ],
              key_points: [
                "Managed using Shape Up and open source style Request for Comments",
                "Added new features and fixed bugs as part of ongoing maintenance",
                "Planned 6 week projects by defining a problem and solution, listing architectural considerations, resources needed (developers, stake holders, etc), and definition of done",
                "Worked with support specialists to clarify requirements and test software to ensure project was headed in correct direction",
                "Helped make project easier to develop by introducing useful README content, a makefile, and infrastructure as code (Terraform)",
                "Encouraged use of TDD, design principles, and design patterns via presentations, book clubs, and hands-on pair programming"
              ]
            },
            {
              project_name: "Strathcom Content Management System",
              link: null,
              description: "Used to host and manage dealership websites",
              duration: "9 Months",
              roles: ["Software Developer"],
              technologies: [
                "Backbone.js",
                "GitHub",
                "Make",
                "PHP",
                "Pantheon",
                "Travis CI",
                "WordPress"
              ],
              key_points: [
                "Managed using Shape Up and open source style Request for Comments",
                "Added new features and fixed bugs as part of ongoing maintenance",
                "Planned 6 week projects by defining a problem and solution, listing architectural considerations, resources needed (developers, stake holders, etc), and definition of done",
                "Worked with support specialists to clarify requirements and test software to ensure project was headed in correct direction",
                "Helped make project easier to develop by introducing useful README content and a makefile",
                "Encouraged use of TDD, design principles, and design patterns via presentations, book clubs, and hands-on pair programming"
              ]
            },
            {
              project_name: "Inventory API",
              link: null,
              description:
                "Strathcom's internal API used for retrieving vehicle data",
              duration: "9 Months",
              roles: ["Software Developer"],
              technologies: [
                "AWS Cloudformation",
                "AWS ECR",
                "AWS ECS",
                "AWS Route53",
                "GitHub",
                "GraphQL",
                "Jenkins",
                "Make",
                "Python",
                "Sanic",
                "SQL"
              ],
              key_points: [
                "Managed using Shape Up and open source style Request for Comments",
                "Added new features and fixed bugs as part of ongoing maintenance",
                "Planned 6 week projects by defining a problem and solution, listing architectural considerations, resources needed (developers, stake holders, etc), and definition of done",
                "Worked with support specialists and subject matter experts to clarify requirements and test software to ensure project was headed in correct direction",
                "Helped make project easier to develop by introducing useful README content and a makefile",
                "Encouraged use of TDD, design principles, and design patterns via presentations, book clubs, and hands-on pair programming"
              ]
            },
            {
              project_name: "Admin Tools",
              link: null,
              description:
                "An Admin dashboard used by support specialists to support customers",
              duration: "2 Months",
              roles: ["Software Developer"],
              technologies: [
                "AWS Cloudformation",
                "AWS ECR",
                "AWS ECS",
                "AWS Route53",
                "Docker",
                "GitHub",
                "GraphQL",
                "Javascript",
                "Jenkins",
                "Jest",
                "Nuxt.js",
                "Vue.js"
              ],
              key_points: [
                "Added new features and fixed bugs as part of ongoing maintenance",
                "Communicated customer support specialists on a daily basis to clarify requirements and test software to ensure project was headed in correct direction"
              ]
            }
          ]
        },
        {
          company_name: "nVent",
          description:
            "nVent is a global leader in enclosures, electric heat-tracing solutions, complete heat-management systems and electrical and fastening solutions.",
          website: "https://www.nvent.com",
          start: "July 2012",
          end: "June 2019",
          projects: [
            {
              project_name: "Single Sign-On",
              link: null,
              description:
                "The Single Sign-On project was started to replace the aging login system that was in place at nVent.",
              duration: "4 months",
              roles: ["Software Developer", "Product Owner"],
              technologies: [
                "Auth0",
                "C#",
                "Cake",
                "Git",
                "GitLab CI",
                "GitLab",
                "OpenID Connect",
                "SpecFlow",
                "Terraform",
                "Visual Studio",
                "YouTrack",
                "xUnit"
              ],
              key_points: [
                "Managed using SCRUM",
                "New product development",
                "Led analysis, breakdown, and estimation of user stories during bi-weekly backlog grooming",
                "Led bi-weekly sprint planning to ensure priority features were being done and enough work was available for next 2 weeks",
                "Led bi-weekly sprint demos with stakeholders and users to ensure project was headed in correct direction",
                "Leveraged subject matter experts to perform user acceptance testing",
                "Wrote code using Behavior Driven Design, Test Driven Design, SOLID principles, and various design patterns",
                "Contributed to entire stack (deploy pipeline, cloud provisioning, UI, backend services",
                "Researched and created proof of concepts for various Single Sign-On providers",
                "Communicated with various Single Sign-On vendors to learn more about pricing and options",
                "Contributed as SCRUM master by facilitation the SCRUM process at all stages",
                "Worked with IT, marketing experts, and lawyers to clarify requirements and test software to ensure project was headed in correct direction"

              ]
            },
            {
              project_name: "Circuit Designer",
              link: null,
              description:
                "A modern web app that allows engineers to manage large projects and design electrical heat tracing circuits. Circuit Designer leverages nVent's new Cloud Services platform",
              duration: "6 Months",
              roles: ["Architect", "SCRUM Master"],
              technologies: [
                "AngularJS",
                "AWS Cloudfront",
                "AWS ACM",
                "AWS S3",
                "Cake",
                "Git",
                "GitLab",
                "GitLab CI",
                "Jasmine",
                "Selenium",
                "Terraform",
                "TypeScript",
                "Visual Studio",
                "YouTrack"
              ],
              key_points: [
                "Managed using SCRUM",
                "New product development",
                "Identified user roles and found stakeholders to represent those user roles",
                "Participated in and facilitated analysis, breakdown, and estimation during bi-weekly backlog grooming",
                "Participated in and facilitated sprint planning to ensure priority features were being done and enough work was available for next 2 weeks",
                "Participated in and facilitated bi-weekly sprint demos with stakeholders and users to ensure project was headed in correct direction",
                "Communicated with stakeholders on a daily basis to clarify requirements and test software to ensure project was headed in correct direction",
                "Researched AngularJS, React, and Vue.js and helped team build consensus on which framework to use",
                "Introduced and taught AngularJS to team via presentations, documentation, and hands-on pair programming",
                "Contributed as architect through creation of technical documentation, guidance during story estimation, and guidance during development",
                "Contributed as SCRUM master by facilitation the SCRUM process at all stages",
              ]
            },
            {
              project_name: "Cloud Services",
              link: null,
              description:
                "Cloud Services is an internal group of REST APIs created to replace existing services currently hosted on premise. Cloud Services is built upon new a new microservices architecture that allows it to scale and iterate quickly.",
              duration: "1 Year",
              roles: ["Software Developer", "Architect", "SCRUM Master"],
              technologies: [
                "AWS Lambda",
                "AWS API Gateway",
                "AWS IAM",
                "AWS Cloudwatch",
                "AWS SQS",
                "AWS SNS",
                "AWS RDS/PostgreSQL",
                "AWS DynamoDB",
                "AWS Route53",
                "AWS ACM",
                "AWS S3",
                "C#",
                "Cake",
                "Git",
                "GitLab",
                "GitLab CI",
                "SQL",
                "SpecFlow",
                "Terraform",
                "Visual Studio",
                "xUnit",
                "YouTrack"
              ],
              key_points: [
                "Managed using SCRUM",
                "New product development",
                "Participated in and facilitated analysis, breakdown, and estimation of user stories during bi-weekly backlog grooming",
                "Participated in and facilitated sprint planning to ensure priority features were being done and enough work was available for next 2 weeks",
                "Participated in and facilitated bi-weekly sprint demos with stakeholders and users to ensure project was headed in correct direction",
                "Encouraged use of Test Driven Design, SOLID principles, and various design patterns",
                "Researched, introduced, and taught microservices, infrastructure as code, AWS, REST, and NoSQL to team via presentations, documentation, and hands-on pair programming",
                "Contributed as architect through creation of technical documentation, guidance during story estimation, and guidance during development",
                "Contributed as SCRUM master by facilitation the SCRUM process at all stages",
                "Worked with engineers to clarify requirements  and test software to ensure project was headed in correct direction"
              ]
            },
            {
              project_name: "TraceCalc Net",
              link:
                "https://raychem.nvent.com/en-ca/tracecalc-net",
              description:
                "TraceCalc Net is an easy-to-use, online design tool that lets you design a pipe heat tracing system for industrial applications",
              duration: "6 Months",
              roles: ["Software Developer", "Product Owner"],
              technologies: [
                ".NET Core",
                "ASP.NET Core",
                "Autofac",
                "Bootstrap",
                "Bower",
                "C#",
                "Cake",
                "Git",
                "GitLab",
                "GitLab CI",
                "JavaScript",
                "JQuery",
                "Razor",
                "SQL",
                "SQLite",
                "SpecFlow",
                "Selenium",
                "TypeScript",
                "Visual Studio",
                "xUnit",
                "YouTrack"
              ],
              key_points: [
                "Managed using SCRUM",
                "New product development followed by ongoing maintenance after initial release",
                "Identified user roles and found stakeholders to represent those user roles",
                "Led analysis, breakdown, and estimation during bi-weekly backlog grooming",
                "Led sprint planning to ensure priority features were being done and enough work was available for next 2 weeks",
                "Led bi-weekly sprint demos with stakeholders and users to ensure project was headed in correct direction",
                "Wrote code using Behavior Driven Design, Test Driven Design, SOLID principles, and various design patterns",
                "Worked with engineers and product owner to clarify requirements and test software to ensure project was headed in correct direction",
                "Contributed as product owner by ensuring vision was well communicated to both stakeholders and developers",
                "Contributed as developer by contributing code to entire stack by (deploy pipeline, frontend, backend)"
              ]
            },
            {
              project_name: "TraceCalc Pro For Buildings",
              link:
                "https://raychem.nvent.com/en-ca/resources/design-tools/tracecalc-pro-for-buildings",
              description:
                "TraceCalc Pro For Buildings is an intuitive, easy-to-use, online design tool that lets you create simple or complex heat-tracing designs for pipes for commercial and residential applications",
              duration: "6 Months",
              roles: ["Software Developer"],
              technologies: [
                ".NET Core",
                "ASP.NET Core",
                "Autofac",
                "Bootstrap",
                "Bower",
                "C#",
                "Cake",
                "Git",
                "GitLab",
                "GitLab CI",
                "JavaScript",
                "JQuery",
                "Microsoft SQL Server",
                "Razor",
                "SQL",
                "SpecFlow",
                "Selenium",
                "TypeScript",
                "Visual Studio",
                "xUnit",
                "YouTrack"
              ],
              key_points: [
                "Managed using SCRUM",
                "New product development followed by ongoing maintenance after initial release",
                "Participated in analysis, breakdown and estimation of user stories during bi-weekly backlog grooming",
                "Participated in sprint planning to ensure priority features were being done and enough work was available for next 2 weeks",
                "Participated in bi-weekly sprint demos with stakeholders and users to ensure project was headed in correct direction",
                "Wrote code using Behavior Driven Design, Test Driven Design, SOLID principles, and various design patterns",
                "Contributed to entire stack (deploy pipeline, client side scripts, UI, backend services",
                "Worked with engineers, marketing experts, and developers to clarify requirements and test software to ensure project was headed in correct direction"
              ]
            },
            {
              project_name: "Roof and Gutter De-Icing Calculator",
              link:
                "https://raychem.nvent.com/en-ca/resources/design-tools/roof-gutter-de-icing-calculator",
              description:
                "Roof & Gutter De-Icing Calculator is an easy-to-use, online design tool that lets you design a roof & gutter de-icing system",
              duration: "4 months",
              roles: ["Software Developer, Product Owner"],
              technologies: [
                ".NET Framework",
                "ASP.NET",
                "Bootstrap",
                "Bower",
                "C#",
                "Cake",
                "Git",
                "GitLab CI",
                "JavaScript",
                "JQuery",
                "Microsoft SQL Server",
                "Razor",
                "SQL",
                "SQLite",
                "SpecFlow",
                "Selenium",
                "TypeScript",
                "Visual Studio",
                "xUnit",
                "YouTrack"
              ],
              key_points: [
                "Managed using SCRUM",
                "New product development followed by ongoing maintenance after initial release",
                "Stepped into product owner role",
                "Was sole developer",
                "Identified user roles and found stakeholders to represent those user roles",
                "Led analysis, breakdown, and estimation during bi-weekly backlog grooming",
                "Led sprint planning to ensure priority features were being done and enough work was available for next 2 weeks",
                "Led bi-weekly sprint demos with stakeholders and users to ensure project was headed in correct direction",
                "Wrote code using Behavior Driven Design, Test Driven Design, SOLID principles, and various design patterns",
                "Contributed to entire stack (deploy pipeline, frontend, backend)",
                "Worked with engineers, marketing experts, and product sales people to clarify requirements and test software to ensure project was headed in correct direction"
              ]
            },
            {
              project_name: "TraceCalc Engine",
              link: null,
              description:
                "An internal library consisting of a variety of tools to aid in the design of a pipe heat tracing system. Intended to be used in a variety of different applications on different platforms such as an iPad app, a REST API, and a web application",
              duration: "3 Years",
              roles: ["Software Developer"],
              technologies: [
                ".NET Core",
                ".NET Framework (later converted to .NET Core)",
                "Autofac",
                "C#",
                "Cake",
                "Git",
                "GitLab",
                "GitLab CI",
                "Jenkins (later replaced with GitLab CI)",
                "Mercurial (later replaced with Git)",
                "Ninject (later replaced with Autofac)",
                "SQL",
                "SQLite",
                "SpecFlow",
                "Visual Studio",
                "xUnit",
                "YouTrack"
              ],
              key_points: [
                "Managed using SCRUM",
                "New product development followed by ongoing maintenance after initial release",
                "Participated in analysis, breakdown and estimation of user stories during bi-weekly backlog grooming",
                "Participated in sprint planning to ensure priority features were being done and enough work was available for next 2 weeks",
                "Participated in bi-weekly sprint demos with stakeholders and users to ensure project was headed in correct direction",
                "Wrote code using Behavior Driven Design, Test Driven Design, SOLID principles, and various design patterns",
                "Contributed to entire stack (deploy pipeline, desktop client, backend services",
                "Worked with engineers and product owner to clarify requirements and test software to ensure project was headed in correct direction"
              ]
            },
            {
              project_name: "TRACERLYNX",
              link: "https://tracer.nvent.com/engineering-design",
              description: "TRACERLYNX is one powerful database combining all client information, design data, and deliverables in a singular program. With TRACERLYNX, every element needed to design a full heat management system can be imported to one system, where the entire project can be managed and designed. From heat loss calculations to cable selection and power connection placement, TRACERLYNX does it all - leading to a more efficient and accurate project.",
              duration: "2 Years",
              roles: ["Software Developer"],
              technologies: [
                ".NET Framework",
                "C#",
                "Castle Windsor",
                "Mercurial",
                "Microsoft Message Queueing",
                "Microsoft SQL Server",
                "NHibernate",
                "NService Bus",
                "NUnit",
                "Rake",
                "Ruby",
                "SQL",
                "Team City",
                "Visual Studio",
                "YouTrack",
                "WPF/XAML",
                "WinForms"
              ],
              key_points: [
                "Managed  using a mix of SCRUM and Lean/Kanban",
                "Added new features and fixed bugs as part of ongoing maintenance",
                "Participated in analysis, breakdown and estimation of user stories during just-in-time backlog grooming",
                "Wrote code using Test Driven Design, SOLID principles, and various design patterns",
                "Contributed to entire stack of N-Tier application (deploy pipeline, desktop client, multiple backends",
                "Worked with engineers and business analyst to clarify requirements and test software to ensure project was headed in correct direction"
              ]
            }
          ]
        },
        {
          company_name: "Hole School of Construction Engineering",
          description:
            "Since its establishment in 1990, the Hole School of Construction Engineering (known at the time as the Construction Engineering and Management Group) has helped the construction industry in Alberta improve its project performance and enhance its competitive position by delivering cutting-edge tools and practices to construction owners, contractors, and tradespeople while providing a unique training opportunity for hundreds of highly qualified personnel.",
          website:
            "https://www.ualberta.ca/engineering/research/groups/construction-engineering",
          start: "May 2010",
          end: "September 2011",
          projects: [
            {
              project_name: "Simphony",
              link:
                "https://www.ualberta.ca/engineering/research/groups/construction-simulation/simphony",
              description:
                "Simphony is a simulation-modeling environment that may be applied to many aspects and fields within construction engineering and management.",
              duration: "16 Months",
              roles: ["Intern Software Developer"],
              technologies: [
                "C#",
                "Microsoft Access",
                "SQL",
                "Source Safe",
                "Visual Studio",
                "WinForms"
              ],
              key_points: [
                "Built steel fabrication and land reclaimation simulations",
                "Added new features and fixed bugs as part of ongoing maintenance",
                "Worked with engineers to clarify requirements",
                "Participated in weekly update meetings",
                "Used Microsoft Visio to build mock UIs"
              ]
            }
          ]
        }
      ]
    };
  }
};
</script>
